import math
import random
from matplotlib.pyplot import *

hcx = [0, -19, -19, 0, 19, 19, 0]
hcy = [22, 11, -11, -22, -11, 11, 22]

ox = [55, 28, -28, -55, -28, 28, 55]
oy = [0, -47, -47, 0, 47, 47, 0]

def go(x, y, t, rvel, lvel):
	v = (rvel + lvel) / 2.0
	t = t*.0174532925
	x1 = x + v*math.cos(t)
	y1 = y + v*math.sin(t)
	t += (rvel-lvel)/6.0
	x2 = x + v*math.cos(t)
	y2 = y + v*math.sin(t)
	return ( (x1+x2)/2, (y1+y2)/2, circ(t/.0174532925))
	
def circ(a):
	if a > 0:
		a %= 360
		if a < 180:
			return a
		return a - 360
	a = (-a)%360
	if a < 180:
		return -a
	return 360 - a

def err(f, t):
	return circ(t-f)

def vel(me, goal, g1, g2):
	rm = math.sqrt(me[0]**2 + me[1]**2)
	rg = math.sqrt(goal[0]**2 + goal[1]**2)
	dt = (rm+rg)*err(57.29578*math.atan2(me[1], me[0]), 57.29578*math.atan2(goal[1], goal[0]))/57.29578/2
	
	fvel = math.sqrt( (rm-rg)**2 + (dt)**2 )
	desired = 57.29578*( math.atan2(dt,rg-rm) + math.atan2(me[1],me[0]) )
	ang = err(me[2],desired)

	if abs(ang) > 90:
		fvel = -fvel
		ang = circ(2*ang)/2.0

	return(g1*fvel*math.cos(ang/57.29578), g2*ang)

#call this method to simulate driving to a point with our spiral controller
#me: tuple of (x,y,heading degrees); goal: (x,y) i:iterations; g1&g2: gains, should be in the range [.01,.1] 
def doAll(me,goal,i,g1,g2):
	xs = []
	ys = []
	for k in xrange(i):
		xs.append(me[0])
		ys.append(me[1])
		f,r = vel(me, goal, g1, g2)
		me = go(me[0],me[1],me[2], f+r,f-r)
		print me
	plot(xs,ys, 'b')
	plot(ox,oy, 'r')
	plot(hcx, hcy, 'r')
	show()
