#include <joyos.h>
#include "locom.h"
//#include <happylib.h>
#include <math.h>

#define PORT (23)
#define LSB 1400000

#define easyDrive(a, t) ( persistentDrive(a, t) )
#define easyTurn(a,t) ( proportionalTurnTo( a, t, 1.9, 2.5 ) )
#define secsLeft ( (START - get_time())/1000.0 )
#define chuteFull ( analog_read(15) > 550 )
#define frontContact ( digital_read(7) == 1 )
#define rearContact ( digital_read(0) == 1 )

extern volatile uint8_t robot_id;

int usetup (void) {
	robot_id = 13;
	printf("place robot then press GO");
	//go_click();
	//irdist_set_calibration(S_M,S_C);
	printf("stabilizing ... do not touch robot");
		
	//init_pid( &headingPID, 4,  1, -.4,  &getHeading,  &rotate);
			
	pause (3000);
	printf("...");
	gyro_init( PORT, LSB, 1000L );
	calibrate();
	pickSides();
	return 0;
}

int8_t nextGood(Point* me){
	int8_t now = territory(me);
	Point opp = {.x = oppX(), .y = oppY()};
	int8_t otter = territory(&opp);
	for (int i = 1; i < 7; i++){
		int terr = (6 + now +i/2*(int)pow(-1,i-1))%6;
		if (otter != terr && (game.territories[terr].remaining > 0 || game.territories[terr].rate_limit < 6)){
			return terr-now;
		}
	}
	return 13;
}
void robustClaim(int terit){
	calibrate();
	Point targ = gearLocation(terit);
	easyDrive(&targ, 3);
	calibrate();
	easyTurn( wallAngle(&targ),4 );
	targ = gearTurnLoc(terit); 
	radianDrive(&targ, 1, 15, 3.8, 1);
	/*if ( abs(makeCircular(getHeading()-wallAngle(&targ) )) > 10 || distanceBetween(myX(), myY(), targ.x, targ.y) > 3.5 ){
		setPair(-80,-80);
		pause(400);
		easyTurn( angleOf(targ.x, targ.y),5 );
	}*/
	setPair(140,140);
	pause(600);
	setPair(0,0);
	int time = 1400;
	while(!claim(time)){
		if (time < 2100){
			time = 6*time/5;
			setPair(-100,-100);
			pause(600);
			setPair(0,0);
			easyTurn(wallAngle(&targ),3);
			setPair(100,100);
			pause(860);
			setPair(0,0);
		}
		else{
			time = 1000;
			calibrate();
			targ = gearLocation(terit);
			easyDrive( &targ, 4 );
			easyTurn(wallAngle(&targ),3);
			targ = gearTurnLoc(terit); 
			radianDrive(&targ, 2, 15, 3.8, 1);
		}
	}
	//targ = gearLocation(terit);
	//easyDrive(&targ, 4);
}

int umain(void) {
	
	long START = get_time() + 120000;
	calibrate();
	
	//Point me = {.x = myX(), .y = myY()};
	Point targ = rotatePoint(&HOME,171);
	easyDrive(&targ,6);
	targ = gearLocation((territory(&targ)+2)%6);
	easyDrive(&targ,3);
	
	bool hasBalls = false;
	int balls = 0; //replace whith chute full
	
	while (true){
		Point me = {.x = myX(), .y = myY()};
		int8_t next = nextGood(&me);
		
		if ( (balls > 2 && chuteFull) || ( (next == 13 || secsLeft < 37) && hasBalls)){ //chute full or no balls left
			calibrate();
			easyDrive(dumpSite(), 3);
			calibrate();
			me.x = myX();
			me.y = myY();
			easyTurn( territory(&me)*60, 4 );
			int att = 0;
			while(att < 3){
				long start = get_time();
				setPair(-200,-200);
				while(get_time()-start < 2000 && distanceBetween(0,0,myX(),myY()) > 19.5){
					copy_objects();
				}
				if (distanceBetween(0,0,myX(),myY()) > 25){
					att++;
					easyDrive(dumpSite(), 3);
					easyTurn( territory(&me)*60, 4 );
				}
				else{
					break;
				}
			}
			setPair(0,0);
			releaseBalls();
			balls = 0;
			hasBalls = false;
		}
		else if (next == 13){
			for (int i = 0; i < 5; i++){
				if (game.territories[(territory(&me)-i+6)%6].owner != 13){
					robustClaim((territory(&me)-i+6)%6);
					break;
				}
			}
		}
		else{
			bool failure = true;
			next = (next + territory(&me) + 6)%6;
			while(failure){
				if ( game.territories[next].owner != 13 ){
					robustClaim(next);
				}
				if (game.territories[next].remaining == 0 && game.territories[next].rate_limit > 6){
				break;
				}
				targ = leverLocation(next);
				calibrate();
				easyDrive( &targ, 2.5 );
				//me.x = myX();
				//me.y = myY();
				calibrate();
				targ = leverPullLoc(next);
				easyTurn( wallAngle(&targ), 4 );
				radianDrive(&targ, 1, 15, 3.8, 1);
				//easyTurn(wallAngle(&targ),3);
				if (!frontContact){
					long st = get_time();
					setPair(110,110);
					while(!frontContact && get_time()-st < 800);
				}
				for (int i = 0; i < 2; i++){
					if(mine()){
						failure = false;
						hasBalls = true;
						balls++;
						break;
					}
					setPair(-70,-70);
					pause(500);
					setPair(0,0);
					pause(20);
					calibrate();
					easyTurn( wallAngle(&targ), 5 );
					setPair(80,80);
					long st = get_time();
					while(!frontContact && get_time()-st < 500);
					setPair(0,0);
				}
				
				setPair(-200,-200);
				pause(700);
				setPair(0,0);
			}		
		}
	}
	return 0;
}